Unit AEE7R_p;
interface
uses
SysUtils, Math, { Delphi }
Lstruct, Lfunc, AMA1R_p;

procedure AEE7R(var A :Array of Real; var B :Array of Real;
                N :Integer; M1 :Integer; M2 :Integer;
                var RU :Array of Real; var W :Array of Real);

implementation

procedure AEE7R(var A :Array of Real; var B :Array of Real;
                N :Integer; M1 :Integer; M2 :Integer;
                var RU :Array of Real; var W :Array of Real);
var
J,I,I1,I2,D,F,G,R,P1 :Integer;
K,L,M,EPS,T,U,X,Y,WMIN2,HM :Real;
const
SYS051 :Real = 1.192093E-07;
label
_1,_2,_3,_4,_5,_6,_7,_8,_9,_10,_11,_12;
begin
WMIN2 := SYS051;
W[0] := A[0];
if ( N = 1 ) 
 then goto _12;
W[0] := 0.0;
AMA1R(A,B,N,K,L,HM,P1);
Y := EMax1(Abs(L),Abs(K));
EPS := Y*WMIN2;
for I:=M1 to M2 do
 begin
  W[I-1] := K;
_1:
  RU[I-1] := L;
 end;
R := M1+M2;
for I1:=M1 to M2 do
 begin
  D := R-I1;
  K := W[D-1];
  if ( L > RU[D-1] ) 
   then L := RU[D-1];
  I2 := M1+D;
  for J:=M1 to D do
   begin
    I := I2-J;
    if ( K >= W[I-1] ) 
     then goto _2;
    K := W[I-1];
    goto _3;
_2:
   end;
  T := 2.0*WMIN2;
_3:
  M := (K+L)*0.5;
  if ( L-K <= (Abs(L)+Abs(K))*T+EPS ) 
   then goto _9;
  F := 0;
  X := A[0]-M;
  if ( X < 0.0 ) 
   then F := 1;
  for J:=2 to N do
   begin
    U := B[J-1];
    if ( X <> 0.0 ) 
     then goto _4;
    Y := Abs(U)/WMIN2;
    goto _5;
_4:
    Y := (U/X)*U;
_5:
    X := A[J-1]-M-Y;
    if ( X < 0.0 ) 
     then F := F+1;
_6:
   end;
  if ( F >= D ) 
   then goto _8;
  K := M;
  if ( F >= M1 ) 
   then goto _7;
  W[M1-1] := M;
  goto _3;
_7:
  G := F+1;
  W[G-1] := M;
  if ( RU[F-1] > M ) 
   then RU[F-1] := M;
  goto _3;
_8:
  L := M;
  goto _3;
_9:
  W[D-1] := M;
_10:
 end;
if ( P1 = 0 ) 
 then goto _12;
HM := 1.0/HM;
for I:=M1 to M2 do
 begin
_11:
  W[I-1] := W[I-1]*HM;
 end;
_12:
end;

end.
