Unit AMA1R_p;
interface
uses
SysUtils, Math, { Delphi }
Lstruct, Lfunc;

procedure AMA1R(var A :Array of Real; var B :Array of Real;
                N :Integer; var Q :Real; var R :Real; var HM :Real;
                var P :Integer);

implementation

procedure AMA1R(var A :Array of Real; var B :Array of Real;
                N :Integer; var Q :Real; var R :Real; var HM :Real;
                var P :Integer);
var
I,J,L :Integer;
S,Y,Z,BA,T,U :Real;
const
WMM :Real = 2.0E0;
WM1 :Real = 2.0E-31;
label
_1,_2,_3,_4,_5,_6;
begin
{      WMM= SQRT(SYS053*SYS055) }
{      WM1= SYS055/SYS051 }
P := 0;
S := Abs(B[1]);
for J:=2 to N do
 begin
_1:
  S := EMax1(S,Abs(B[J-1]));
 end;
if ( S <= WMM ) 
 then goto _2;
P := 1;
HM := WMM/S;
_2:
B[0] := 0.0;
Z := Abs(B[N-1]);
R := A[N-1]+Z;
Q := A[N-1]-Z;
L := N-1;
for I:=1 to L do
 begin
  J := N-I;
  BA := Z;
  Z := Abs(B[J-1]);
  T := A[J-1];
  U := BA+Z;
  R := EMax1(R,T+U);
_3:
  Q := EMin1(Q,T-U);
 end;
if ( P = 1 ) 
 then goto _4;
Y := EMax1(Abs(R),Abs(Q));
if ( Y > WM1 ) 
 then goto _6;
if ( Y = 0.0 ) 
 then goto _6;
P := 1;
HM := WM1/Y;
_4:
for I:=1 to N do
 begin
  A[I-1] := A[I-1]*HM;
_5:
  B[I-1] := B[I-1]*HM;
 end;
R := R*HM;
Q := Q*HM;
_6:
end;

end.
